# Container

Это основной класс который реализует 
[psr/container](https://github.com/php-fig/fig-standards/blob/master/accepted/PSR-11-container-meta.md). 

Основным аргументом конструктора мы получаем элементы **ProviderInterface**, которые используются для расширения 
возможностей настройки **Container**, [более подробно о провайдерах](provider.md).

Порядок провайдеров в массиве важен, если будет два провайдера, предоставляющих одинаковые имена контейнеров, то будет 
использоватся тот что добавлен в начале, [подробней о приоритете провайдеров](providerPrioritet.md).

**Container** использует только те провайдеры что ему были переданы в конструтор, это позволяет подключать 
только тот функционал что необходим проекту, расширяя возможности **Container** с помощью провайдеров.

**ProviderInterface** может возвращать объекты реализующие **LoaderInterface** и обработка этих объектов в 
**Container** будет отличаться, [подробней о LoaderInterface](loader.md).

Когда мы узнали о существование **Container**, **ProviderInterface** и **LoaderInterface** 
[рассмотрим пример настройки и то как все это работает вместе](exampleConfiguration.md).

**Container** позволяет защитится от ситуации когда разрешение зависимостей может продолжатся бесконеноч 
(А зависит от Б и соответсвенно Б зависит от А), [подробней о такой ситуации](infiniteRecursion.md).

**Container** позволяет получать дерево зависимостей ваших объектов, 
[подробней о получения дерева зависимостей](dependency.md).

Более подробные примеры использования смотри в [этом unit тесте](../test/Unit/ContainerTest.php)